/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


#include <iostream.h>
#include <it.h>

int
main(int, char **)
{
    // Make a connection using defaults
    ITConnection conn;
    conn.Open();

    // Create a query object
    ITQuery q(conn);

    // Retrieve a row from the database
    ITRow *row;           
    row = q.ExecOneRow("select unique count(*) from informix.systables where tabname in ('systables', 'syscolumns', 'sysviews');");

    // Check to see if any rows were returned
    if (row == NULL)
    {
        cout << "cnvex: no rows returned by ITQuery::ExecOneRow" << endl;
        cout << "cnvex: exiting" << endl;
        return 1;
    }

    ITValue *v = row->Column(0);
    ITConversions *c;                                                    // 1

    // Extract an interface. The return code IT_QUERYINTERFACE_SUCCESS
    // should be used for compatibility reasons.
    if (v->QueryInterface(ITConversionsIID, (void **) &c)
        == IT_QUERYINTERFACE_SUCCESS)
    {

        short short_tabcnt;
        int int_tabcnt;
        long long_tabcnt;
        float float_tabcnt;
        double double_tabcnt;
        const char *cstring_tabcnt;
        ITString itstring_tabcnt;
        
        if (c->ConvertTo(short_tabcnt))
        {
            cout << "SQL Integer as short: "
                 << short_tabcnt
                 << endl;
        }
        
        if (c->ConvertTo(int_tabcnt))
        {
            cout << "SQL Integer as int: "
                 << int_tabcnt
                 << endl;
        }
        
        if (c->ConvertTo(long_tabcnt))
        {
            cout << "SQL Integer as long: "
                 << long_tabcnt
                 << endl;
        }
        
        if (c->ConvertTo(float_tabcnt))
        {
            cout << "SQL Integer as float: "
                 << float_tabcnt << endl;
        }
        
        if (c->ConvertTo(double_tabcnt))
        {
            cout << "SQL Integer as double: "
                 << double_tabcnt
                 << endl;
        }
        
        if (c->ConvertTo(cstring_tabcnt))
        {
            cout << "SQL Integer as C string: "
                 << cstring_tabcnt
                 << endl;
        }
        
        if (c->ConvertTo(itstring_tabcnt))
        {
            cout << "SQL Integer as ITString: "
                 << itstring_tabcnt
                 << endl;
        }
        
        // Release the conversions interface
        c->Release();
    }

    // Release the value interfaces
    v->Release();
    row->Release();

    return 0;
}


