/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


//  Title: dtex.cpp
//  Description:
//	 Date/Time example

#include <iostream.h>
#include <it.h>

int
main(int, char **)
{
    // Make a connection using defaults
    ITConnection conn;
    conn.Open();

    // Create a query object
    ITQuery q(conn);

    // Retrieve a row from the database
    ITRow *row;           
    row = q.ExecOneRow("select datetime_val from regresstab;");

    if (row == NULL)
    {
        cout << "dtex: no rows returned by ITQuery::ExecOneRow" << endl;
        cout << "dtex: exiting" << endl;
        return 0;
    }

    ITValue *v = row->Column(0);

    ITDateTime *dt;                                                // 1 begin

    // Extract an interface. The return code IT_QUERYINTERFACE_SUCCESS
    // should be used for compatibility reasons.
    if (v->QueryInterface(ITDateTimeIID, (void **) &dt)
        == IT_QUERYINTERFACE_SUCCESS)
    {
        cout << "The date value is: " << endl
             << "Year:" << dt->Year() << endl
             << "Month: " << dt->Month() << endl
             << "Day: " << dt->Day() << endl
             << "Hour: " << dt->Hour() << endl
             << "Minute: " << dt->Minute() << endl
             << "Second: " << dt->Second() << endl;
        
        // Release the Date/Time interface
        dt->Release();
    }                                                             // 1 end

    // Release the value interfaces
    v->Release();
    row->Release();

    return 0;
}


