--***************************************************************************
-- *
-- *                               IBM INC.
-- *
-- *                           PROPRIETARY DATA
-- *
-- * Licensed Material - Property Of IBM
-- *
-- * "Restricted Materails of IBM"
-- *
-- * IBM Informix Client SDK
-- *
-- * (c)  Copyright IBM Corporation 2002. All rights reserved.
-- *
-- ****************************************************************************
-- */


create distinct type testtype as integer;

create row type foo_t (a character varying (20));
create table foo of type foo_t;
insert into foo values ('foobar');
create row type bar_t (b integer) under foo_t;
create table bar of type bar_t under foo;
insert into bar values ('barfoo', 5);
insert into bar values ('foobar1', 1);
insert into bar values (NULL, 3);

create row type cnstr_type
(
	a integer,
	b character varying (10)
);

create table regresstab
(
	boolean_val boolean,
	char_val char(1),
	character_val character(10),
	date_val date,
	datetime_val datetime year to fraction,
	dec_val dec,
	decimal_val decimal(5,3),
	double_val double precision,
	float_val float(2),
	int_val int,
	int8_val int8,
	integer_val integer,
	interval_ds_val interval day to second,
	interval_ym_val interval year to month,
	lvarchar_val lvarchar,
	numeric_val numeric(5),
	money_val money(5,2),
	real_val real,
	serial_val serial(10),
	smallfloat_val smallfloat,
	smallint_val smallint,
	text_val text,
	byte_val byte,
	varchar_val varchar(32),
	large_object_val blob,
	large_text_val clob,
	cnstr_val cnstr_type,
	setof_base_val set(integer not null),
	setof_cnstr set(cnstr_type not null),
	boolean_null boolean,
	char_null char(1),
	character_null character(10),
	date_null date,
	datetime_null datetime year to fraction,
	dec_null dec,
	decimal_null decimal(5,3),
	double_null double precision,
	float_null float(2),
	int_null int,
	int8_null int8,
	integer_null integer,
	interval_ds_null interval day to second,
	interval_ym_null interval year to month,
	lvarchar_null lvarchar,
	numeric_null numeric(5),
	money_null money(5,2),
	real_null real,
	smallfloat_null smallfloat,
	smallint_null smallint,
	text_null text,
	varchar_null varchar(32)
);

insert into regresstab
(
	boolean_val,
	char_val,
	character_val,
	date_val,
	datetime_val,
	dec_val,
	decimal_val,
	double_val,
	float_val,
	int_val,
	int8_val,
	integer_val,
	interval_ds_val,
	interval_ym_val,
	lvarchar_val,
	numeric_val,
	money_val,
	real_val,
	smallfloat_val,
	smallint_val,
	text_val,
	byte_val,
	varchar_val,
	large_object_val,
	large_text_val,
	cnstr_val,
	setof_base_val,
	setof_cnstr,
	boolean_null,
	char_null,
	character_null,
	date_null,
	datetime_null,
	dec_null,
	decimal_null,
	double_null,
	float_null,
	int_null,
	int8_null,
	integer_null,
	interval_ds_null,
	interval_ym_null,
	lvarchar_null,
	numeric_null,
	money_null,
	real_null,
	smallfloat_null,
	smallint_null,
	text_null,
	varchar_null
)
values
(
	't',				   
	'1',				   
	'fabulous',			   
	'02/13/67',			   
	'1967-02-13 12:42:06.001',	   
	1,				   
	1,				   
	1,				   
	1,				   
	1,				   
	1,                 
	1,				   
	'1 1:33:44',			   
	'1-1',				   
	'ordinary text',		   
	1,				   
	1,				   
	1,				   
	1,				   
	1,				   
	null, 
	null,
	'foo',				   
	filetoblob('sample.txt', 'client'),
	filetoclob('sample.txt', 'client'),
	'row(1,"blerp")',
	'set{1,2,3}',
	'set{row(1,"lvarchar"),row(2,"foo"),row(3,"bar")}',
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null, 
	null  
);


create distinct type bitarray as integer;
create table bitarraytab (bitarraycol bitarray);
insert into bitarraytab values ( '1' );

commit work;
