/****************************************************************************
 *
 *                               IBM INC.
 *
 *                           PROPRIETARY DATA
 *
 * Licensed Material - Property Of IBM
 *
 * "Restricted Materails of IBM"
 *
 * IBM Informix Client SDK
 *
 * (c)  Copyright IBM Corporation 2002. All rights reserved.
 *
 ****************************************************************************
 */


//  Title:	sysname.cpp
//
//  Description:
//	 Example of displaying a system name list, if the command line arg
//	 is passed it checks for the existance of the system name in the
//	 produced system name list and diplay it.
 
				
#include <it.h>
#ifdef IT_WINDOWS
#include <strstrea.h>
#else
#include <strstream.h>
#endif


// Returns the lst system name list member
ITString  DisplaySystemNameList(ITSystemNameList &);

ITCallbackResult
my_error_handler(const ITErrorManager &errorobject,                 
                 void *userdata,
                 long errorlevel)
{
    // Cast the user data into a stream
    ostream *stream = (ostream *) userdata;
    if( 1 < errorlevel )
        (*stream) << "my_error_handler: errorlevel="
                  << errorlevel
                  << " sqlstate="
                  << errorobject.SqlState()
                  << ' '
                  << errorobject.ErrorText()
                  << endl;
    return IT_HANDLED;
}               

int
main(int argc, char **argv)
{
	cout << "Creating a ITSystemNameList with default constructor" << endl;
    ITSystemNameList list;					// 1 begin
								// 1 end
    list.AddCallback( my_error_handler, (void *) &cerr );
    ITBool created = list.Create();				// 1 begin
								// 1 end

    if( !created )
        {
        cout << "System name list creation failure" << endl;
        return -1;
        }
	ITString last = DisplaySystemNameList(list);
    cout << "System is "
         << (list.IsSystemName( 1 < argc ? argv[1] : last.Data() ) 
             ? "" : "not ")
         << "in system name list"
         << endl;
    return 0;
}

//Global Func. Definition

ITString
DisplaySystemNameList(ITSystemNameList &list)
{
  	ITString current, last;

	cout << "Parsing the system name list by calling NextSystemName() method"
         << endl;

	while ( ITString::Null != (current = list.NextSystemName()) )	// 2 begin
        {
		cout << current << "\tALWAYS_DIFFERENT" << endl;
        last = current;
        }								// 2 end
    return last;
}
