#ifndef _IT_H_
#define _IT_H_

//
//
//                                IBM INC.
//
//                           PROPRIETARY DATA
//
// Licensed Material - Property Of IBM
//
// "Restricted Materails of IBM"
//
// IBM Informix Client SDK
//
// (c)  Copyright IBM Corporation 2002. All rights reserved.
//
//
//  Title:	it.h
//  Description:
//   Global header file for Informix C++ Interface
//
 
// PORTABILITY DEFINTIONS

// To be sure about whether you are compiling under Windows, specify
// IT_WINDOWS; otherwise we will attempt to infer it from the other
// defines. 
#if defined(IT_WINDOWS) || defined(_WINDOWS) || defined(_CONSOLE) || defined(_MSC_VER) || defined(WIN32) || defined(_WINDLL)

#ifndef IT_WINDOWS
#define IT_WINDOWS
#endif

#ifndef IT_COM_COMPATIBLE
#define IT_COM_COMPATIBLE
#endif

#ifndef IT_COMPILER_HAS_LONG_LONG
#define IT_COMPILER_HAS_LONG_LONG
#endif
#define IT_LONG_LONG  __int64

#ifndef IT_STATICLIB
# ifdef IT_LIBCOMPILE
#  define IT_EXPORTCLASS __declspec(dllexport)
# else // LIBCOMPILE
#  define IT_EXPORTCLASS __declspec(dllimport)
# endif // LIBCOMPILE
#else
# define IT_EXPORTCLASS
#endif

#pragma warning(disable : 4355)

#ifdef IT_COM_COMPATIBLE
// For definition of ID_IUnknownID
#pragma comment(lib, "uuid.lib")
#endif

#else // WINDOWS

#define IT_EXPORTCLASS

#ifdef IT_COMPILER_HAS_LONG_LONG
#define IT_LONG_LONG  long long
#endif

#endif // WINDOWS

// Macros to translate compiler specific datatypes correctly,
// e.g. 'bool' and 'long double'.
#ifdef	IT_COMPILER_HAS_BOOL
typedef	bool	ITBool;
#else // IT_COMPILER_HAS_BOOL
typedef int	ITBool;

/**************************************************************************
The definition for false & true is required only in AIX 4.3.2 & lower
As the 2.80 builds for CSDK are on 4.3.3, thi shas been commented out.

#ifdef AIX
#define false 0
#define true  1
#endif

** End of comments for AIX 4.3.3 
*****************************************************************************/


#ifndef	IT_DO_NOT_SIMULATE_BOOL
#if defined ( _MSC_VER ) || defined ( UNIXWARE )
// MSVC4 does not define true and false but reserves them
#define false 0
#define true  1
#else
const ITBool false = 0;
const ITBool true = 1;
#endif
#endif // IT_DO_NOT_SIMULATE_BOOL
#endif // IT_COMPILER_HAS_BOOL

#ifndef NULL
#define NULL 0
#endif // NULL

// Some of the classes of the interface refer to LibMI datatypes
// defined in the milib.h header file
extern "C" 
{
#include <mi.h>
}
#undef IGNORE

// Interface forward definitons
#ifndef IT_COM_COMPATIBLE
#define IT_INTERFACE class
#else
#define IT_INTERFACE interface
#endif

#include <itcppval.h>
#include <itcppop.h>

#endif /* _IT_H_ */
